////////////////////////////////////////
//
// Подключение TFT-дисплея
// к плате Arduino Esplora
//   секундомер 
//
////////////////////////////////////////
 
// Библиотека для работы с TFT-экраном
#include <TFT.h> 
#include <SPI.h>

#include <Esplora.h>
 
// переменная для хранения прошедшего времени
int counter = 0;
// переменная для статуса секундомера
boolean start = false;
// переменная для отсчета времени
unsigned long millis1= 0;
// массив символов для вывода времени на экран
char printout[4];
 
void setup(){
  Serial.begin(9600);
  EsploraTFT.begin();  
  // очистка экрана
  EsploraTFT.background(0,0,0); 
  // цвет текста
  EsploraTFT.stroke(0,0,255);
  // выводим статический текст
  EsploraTFT.text("Secundomer:",10,10);
  // увеличиваем размер шрифта для текста, 
  // выводимого в блоке loop() 
  EsploraTFT.setTextSize(3);
}
 
void loop(){
    // определяем нажатие кнопок
    // пуск
    if (Esplora.readButton(SWITCH_1) == LOW) {
       start=true;
       millis1=millis();
       Serial.println("start");
       delay(10);
    }
    // стоп
    if (Esplora.readButton(SWITCH_3) == LOW) {
       start=false;
       Serial.println("stop");
       delay(10);
    }
    // сброс
    if (Esplora.readButton(SWITCH_4) == LOW) {
       counter=0;
       millis1=millis();
       Serial.println("reset");
       // вывод секунд на дисплей
       view_display();
       delay(10);
    }
    // если секундомер включен
    if(start) {
       if(millis()-millis1>=1000) {
          counter=counter+1;
          millis1=millis();
          // вывод секунд на дисплей
          view_display();
       }   
    }

}
// функция вывода показаний секундомера
void view_display() {
   // стираем предыдущее
   EsploraTFT.stroke(0,0,0);
   EsploraTFT.text(printout,20,40);
   // преобразовываем секунды в строку
   String elapsedTime = String(counter);
   // добавляем в массив
   elapsedTime.toCharArray(printout,4);
   // выводим на экран
   EsploraTFT.stroke(255,255,255);
   EsploraTFT.text(printout,20,40);
}


